;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ENCRYPT1.S	 (Parasol Stars version)
; Program to make the self decrypting, memory flushing files
; for use with the normal developemnt process

; this file will be multiply encrypted several times over
; it will decrypt itself backwards when run - the bits of code are added
; so the length of the file will grow, depending on how many levels of coding 
; you use.

; the loader program can ignore first 28 bytes and skip the next four.
; (ie it does not load the first 28 and JMPs to start+4)
; this is so it is compatible with unencrypted files as well

; needs the label IMAGE defined to point to 100k of freem memory

; Configuration :-

k2		equ	100*1024	; maximum length of source data 

the_start	equ	10		; where start is stored
the_length	equ	14		; and len

		if	st

flash_d0	macro
		move.w	d0,$ff8240	; remove this line for no flash
		endm			

		elseif

flash_d0	macro
		move.w	d0,$dff180	; remove this line for no flash
		endm			

		endc


copy	macro	source,dest
	move.l	\1,a0
	move.l	\2,a1
cop\@	move.b	(a0)+,(a1)+
	bne	cop\@
	subq.l	#1,a1
	endm

; now we have to encrypt the file - should return in same place
; with file_len updated to be the new one.


encrypt_file
;	move.w	#$2700,sr	; def no ints !!

; now we need to do the first level on encryption

	bsr	bottom_level

; then all the zillions of nested encryptions

	lea	usage_table,a0		; table of encryption types
.x	move.w	(A0)+,d0		; get type
	bmi.s	.fin			; if -1 then end
	move.l	a0,-(sp)		; 
	bsr	do_encrypt		; encrypt with that code
	move.l	(sp)+,a0		;
	bra	.x			; and repeat
.fin

; then finally make it acceptable to the normal loader program 

;	bsr	top_level

	st	use_file_dest		; 

	rts


; The top stuff to make it into a loadable program
; that will just move stuff to $8 and run it
; can be assumed that the program is already at 8 in runnable form

top_level
	move.l	file_dest,a1
	sub.l	#4+26+4+top_len,a1
	move.l	a1,file_dest
	add.l	#4+26+4+top_len,file_len
	move.w	#$6000+26,(A1)+	; make executable anywhere

	lea	hello_mess,a0
	move.w	#26-1,d0
.c	move.b	(a0)+,(A1)+		; copy in the "Crackers Nightmare"
	dbf	d0,.c

	move.l	#$4e714e71,(a1)+	; and then nop a long

;now append the copying program
	move.l	file_len,top_len_poke
	lea	top_code,a0
	move.l	#top_len,d0
	bsr	insert_prog

	rts


; all top code does is insert a program to move the code down to 8
; and to execute it from there

top_code
; first copy the mover program up so it is not overwritten
	move.w	#$2700,sr		; kill ints!!!!
	lea	top_end(pc),a2
	lea	this_bit(pc),a0
	lea	$78000,a1
	move.w	#100,d0
.x	move.l	(a0)+,(a1)+
	dbf	d0,.x
	jmp	$78000
	dc.b	'   Assembled on \#_day/\#_month/\#_year at \#_hours:\#_minutes:\#_seconds   ',0
	even 
this_bit
	move.l	a2,a0		; get code start back
	lea	$8,a1
top_len_poke	equ	*+2
	move.l	#150000,d0	; max 150k (more than you need)
.y	move.b	(a0)+,(a1)+	; copy it back
	subq.l	#1,d0
	bne	.y
	lea	$8,a6		; a6 points to base of code
	jmp	(a6)
top_end
top_len	equ	top_end-top_code
	
	


; move the program from bbuffer to $8 - adding the relocator prog
; first 18 bytes are bra.s,start,length

bottom_level
	move.l	file_dest,a1
	sub.l	#copy_len+10,a1	
	move.l	a1,file_dest
	move.w	#$6008,(a1)+		; bra.s over the first two long words
	move.l	#8+10+copy_len,(a1)+ 	; the start of data
	move.l	file_len,(a1)+	; then length of data

	lea	copy_code,a0
	move.l	#copy_len,d0
	bsr	insert_prog		; insert the reloc code

	add.l	#copy_len+10,file_len
	rts


; a0 = program,a1 =dest d0 = program length
insert_prog
;	lea	8+10,a1
.x	move.b	(a0)+,(a1)+		; copy the rest of the code in
	subq.l	#1,d0
	bne.s	.x
	rts

; copy back from 8, into the file_dest
copy_back_up
	lea	8,a0
	move.l	file_dest,a1
	move.l	file_len,d0
	lsr.l	#3,d0			; divide by 8
.x	move.l	(a0)+,(a1)+		; copy back into buffer
	move.l	(a0)+,(a1)+
	dbf	d0,.x
	rts


; right - now encryption routines

; this is the very lowest level - just puts the program where it belongs
copy_code
	lea	*-18(pc),a6
	move.l	a6,a0
	add.l	the_start(a6),a0
	move.l	#$40000,a2			; store start addr
	move.l	a2,a1
	move.l	the_length(a6),d0

	add.l	d0,a0			; copy backwards always
	add.l	d0,a1			; as it is now at 8 and going up...
	lsr.l	#1,d0
	addq.l	#1,d0	
.x	move.w	-(a0),-(a1)		; copy it back into buffer
	subq.l	#1,d0
	bne	.x

	move.w	#$2700,sr		; just a reminder....
	jmp	(a2)			; and RUUUUUNNNNNN!!!!!!
copy_end
copy_len equ	copy_end-copy_code


; do one level of encoding, on entry the data is in bbuffer
; and the length is in file_len
; on exit it is the same - but with the exta encryption of course

do_encrypt
	flash_d0	       		; flash border

	move.l	file_dest,a1	 	; current file addr

	lsl.w	#4,d0			; d0 * 16 to get table
	lea 	crypt_table,a4	
	lea	(a4,d0.w),a4		; a4 = table entry
	move.l	12(a4),d0		; d0 = length of decrypt
	sub.l	d0,a1 			; space for code
	sub.l	#10,a1		 	; and header
	move.l	a1,file_dest 		; new file addr

	move.w	#$6008,(a1)+		; bra.s over the first two long words
	add.l	#18,d0
	move.l	d0,(a1)+		; start of data

	move.l	file_len,(a1)+		; then length of data

	subq.l	#8,d0
	add.l	d0,file_len

	move.l	a1,a5
	move.l	(a4),a0
	move.l	4(a4),d0
	bsr	insert_prog		; insert the encrypt code

	lea	-18(a5),a6
	move.l	the_start,-(sp)
	move.l	the_length,-(sp)
	move.l	file_dest,d0
	move.l	the_start(a6),the_start
	add.l	d0,the_start
	subq.l	#8,the_start
	move.l	the_length(a6),the_length
	pushem
	jsr	(a5)			; perform the encode
	popem
	move.l	(sp)+,the_length
	move.l	(sp)+,the_start

	move.l	8(a4),a0
	move.l	12(a4),d0
	move.l	a5,a1			
	bsr	insert_prog		; insert the decrypt code

	rts

; the suicide macro must be the last thing in every decrypt routine

suicide	macro	code routine number
	move.w	#$2700,sr		; kill ints!!!!
	add.l	the_start(a6),a6
	endm	


; How to add your own encryption/decryption routines

; For routines number x the basic structure is as shown below
; the encrypt_code_x routine must end in an rts and 
; the decrypt_code_x must end in a "suicide x"

; the encrypt code must encrypt the code starting at THE_START and
; of length THE_LENGTH bytes - is should still occupy the same space
; if you need to corrupt the stack then store internally first
; you are encouraged to use SR to ensure no tracing but leave it as $27xx

; the decrypt_code must merely perform the opposite function 
; here you can corrupt anything else you want - clear vast areas of memory etc
; the decrypt code must always be bigger than the encrypt code
; this is usually taken care of by having the suicide macro there always

; as you want as many as possible then the quicker they are the better
; so a few speed ideas : 
;  As the length will always be less than 4*64k use DBF stepping long words
;  you only have to encrypty every few bytes after the first level
;  Even one or two bytes will make a difference if you finish with
;  an encryption that takes previous byte/word into account (eg type 1)
;  If you are encrypting everything then use auto increnment and DBF if poss
;  Straightline your code if you must do something to every byte - loadsa RAM!
;  You could just encrypt a few bytes at the start


encrypt_code_x
	rts
encrypt_end_x
encrypt_len_x	equ	encrypt_end_x-encrypt_code_x

decrypt_code_x
	suicide	x
decrypt_end_x
decrypt_len_x	equ	decrypt_end_x-decrypt_code_x

; *********************************************************************
; number 0 encryption routine
; Does bugger all to the data - just bungs on the standard suicide

encrypt_code_0
	rts
encrypt_end_0
encrypt_len_0	equ	encrypt_end_0-encrypt_code_0

decrypt_code_0
	suicide	0
decrypt_end_0
decrypt_len_0	equ	decrypt_end_0-decrypt_code_0


; *********************************************************************
; number 1 encryption routine
; eor each byte with the next so always eoring an encrypted byte except first

encrypt_code_1
	move.l	the_start,a0
	move.l	the_length,d0
.x	move.b	(a0)+,d1
	eor.b	d1,(a0)		; eor each byte with the next
;	flash_d0
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_1
encrypt_len_1	equ	encrypt_end_1-encrypt_code_1

decrypt_code_1
	subq.l	#8,a6
	lea	.x+6(pc),sp
	move.l	the_length(a6),d0
	move.l	a6,a0
	add.l	the_start(a0),a0
	move.b	(a0)+,d1	; d1 = last byte
.x	move.b	(a0),d2		; d2 = encrypted byte
	eor.b	d1,(a0)+	; eor each byte with the next
	move.b	d2,d1		; d1 = the last byte (encoded)
;	flash_d0
	subq.l	#1,d0
	bne.s	.x
	suicide	1
decrypt_end_1
decrypt_len_1	equ	decrypt_end_1-decrypt_code_1

; *********************************************************************
; number 2 encryption routine
; add d0.b to each byte  (d0.b will vary and depend on the length)

encrypt_code_2
	move.l	the_start,a0
	move.l	the_length,d0
.x	add.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_2
encrypt_len_2	equ	encrypt_end_2-encrypt_code_2

decrypt_code_2
	lea	.x+6(pc),sp
	subq.l	#8,a6
	move.l	the_length(a6),d0
	move.l	a6,a0
	add.l	the_start(a0),a0
.x	sub.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	suicide	2
decrypt_end_2
decrypt_len_2	equ	decrypt_end_2-decrypt_code_2

; *********************************************************************
; number 3 encryption routine
; sub d0.b to each byte  (d0.b will vary and depend on the length)

encrypt_code_3
	move.l	the_start,a0
	move.l	the_length,d0
.x	sub.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_3
encrypt_len_3	equ	encrypt_end_3-encrypt_code_3

decrypt_code_3
	subq.l	#8,a6
	move.l	the_length(a6),d0
	lea	.x+6(pc),sp
	move.l	a6,a0
	add.l	the_start(a0),a0
.x	add.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	suicide	3
decrypt_end_3
decrypt_len_3	equ	decrypt_end_3-decrypt_code_3

; *********************************************************************
; number 4 encryption routine
; eor d0.b to each byte  (d0.b will vary and depend on the length)

encrypt_code_4
	move.l	the_start,a0
	move.l	#200,d0
.x	eor.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_4
encrypt_len_4	equ	encrypt_end_4-encrypt_code_4

decrypt_code_4
	subq.l	#8,a6
	move.l	a6,a0
	lea	.x+6(pc),sp
	add.l	the_start(a0),a0
	move.l	#200,d0
.x	eor.b	d0,(a0)+
	subq.l	#1,d0
	bne.s	.x
	suicide	4
decrypt_end_4
decrypt_len_4	equ	decrypt_end_4-decrypt_code_4

; *********************************************************************
; number 5 encryption routine
; eors each word with SR when SR= $2700, and CCR set to TST of last word

encrypt_code_5
	move.w	#$2700,sr
	move.l	the_start,a0
	move.l	#200,d0
	lsr.l	#1,d0			; words !
	addq.l	#2,a0			; skip one word
.x	tst.w	-2(a0)			; test previous word to set flags
	move.w	sr,d1
	eor.w	d1,(a0)+		; eor with ccr
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_5
encrypt_len_5	equ	encrypt_end_5-encrypt_code_5

decrypt_code_5
	subq.l	#8,a6
	move.l	a6,a0
	add.l	the_start(a0),a0
	lea	.x+6(pc),sp
	move.w	#$2700,sr
	move.l	#200,d0
	lsr.l	#1,d0			; words !
	move.w	(a0)+,d2		; skip first but stor it as last
.x	move.w	(a0),d3			; temp store for this word
	tst.w	d2			; test previous for flags
	move.w	sr,d1
	eor.w	d1,(a0)+		; eor with sr and ccr
	move.w	d3,d2			; get back last word
	subq.l	#1,d0
	bne.s	.x

	suicide	5
decrypt_end_5
decrypt_len_5	equ	decrypt_end_5-decrypt_code_5

; *********************************************************************
; number 6 encryption routine
; eors each word with a0 (it's position in memory)

encrypt_code_6
	move.l	the_start,a0
	move.l	#200,d0
.x	
	eor.w	d0,(a0)+		; eor with ccr
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_6
encrypt_len_6	equ	encrypt_end_6-encrypt_code_6

decrypt_code_6
	subq.l	#8,a6
	move.l	a6,a0
	add.l	the_start(a0),a0
	move.l	#200,d0
.x	
	eor.w	d0,(a0)+		; eor with ccr
	subq.l	#1,d0
	bne.s	.x

	suicide	6
decrypt_end_6
decrypt_len_6	equ	decrypt_end_6-decrypt_code_6


; a macro for creating the 4 types of rotation encryption

rot_crypt	macro	number,type,reverse
encrypt_code_\1
	move.l	the_start,a0
	move.l	#200,d0
	lsr.l	#1,d0			; words !
.x	\2	(a0)+			; rotate as specified
	subq.l	#1,d0
	bne.s	.x
	rts
encrypt_end_\1
encrypt_len_\1	equ	encrypt_end_\1-encrypt_code_\1

decrypt_code_\1
	subq.l	#8,a6
	move.l	a6,a0
	add.l	the_start(a0),a0
	move.l	#200,d0
	lea	.x+6(pc),sp
	lsr.l	#1,d0			; words !
.x	\3	(a0)+			; rotate as specified
	subq.l	#1,d0
	bne.s	.x
	suicide	\1
decrypt_end_\1
decrypt_len_\1	equ	decrypt_end_\1-decrypt_code_\1
	endm

; *********************************************************************
; numbers 7 & 8 encryption routines
; rotates each word right or left

	rot_crypt	7,ror.w,rol.w
	rot_crypt	8,rol.w,ror.w

; *********************************************************************
; number 9 encryption routine
; dependant on the position in memory - only does a few bytes

encrypt_code_9
	exg.l	a6,a7
	lea	.there+4(pc),sp
	move.l	the_start,a0
	move.w	#10,d0			; only do 11 lws
.x	bsr	.where
	eor.l	d0,(a0)+
	dbf	d0,.x
	exg.l	a6,a7
	rts
.where	move.l	(sp),d1
	rts
.there	dc.l	0
encrypt_end_9
encrypt_len_9	equ	encrypt_end_9-encrypt_code_9

decrypt_code_9
	exg.l	a6,a7
	lea	.there+4(pc),sp
	move.l	the_start,a0
	move.w	#10,d0			; only do 11 lws
.x	bsr	.where
	eor.l	d0,(a0)+
	dbf	d0,.x
	exg.l	a6,a7
	bra	.die
.where	move.l	(sp),d1
	rts
.there	dc.l	0
.die	suicide	9
decrypt_end_9
decrypt_len_9	equ	decrypt_end_9-decrypt_code_9

; *********************************************************************
; number 10 encryption routine
; dependant on the position in memory and the program

encrypt_code_10
.here	exg.l	a6,a7
	lea	.there+4(pc),sp
	move.l	the_start,a0
	lea	.here(pc),a1
	move.w	#0,d2
	move.w	#10,d0			; only do 11 lws
.x	bsr	.where
	add.w	#2,d2
	and.l	#$f,d2			; range over 16 bytes of the program
	add.l	(a1,d2.w),d1		; add position to contents
	eor.l	d1,(a0)
	eor.l	d2,(a0)+
	dbf	d0,.x
	exg.l	a6,a7
	rts
.where	move.l	(sp),d1
	rts
.there	dc.l	0
encrypt_end_10
encrypt_len_10	equ	encrypt_end_10-encrypt_code_10

decrypt_code_10
.here	exg.l	a6,a7
	lea	.there+4(pc),sp
	move.l	the_start,a0
	lea	.here(pc),a1
	move.w	#0,d2
	move.w	#10,d0			; only do 11 lws
	lea	.x+6(pc),sp
.x	bsr	.where
	add.w	#2,d2
	and.l	#$f,d2			; range over 16 bytes of the program
	add.l	(a1,d2.w),d1		; add position to contents
	eor.l	d1,(a0)
	eor.l	d2,(a0)+
	dbf	d0,.x
	exg.l	a6,a7
	bra.s	.die			; bra.s is same length as rts
.where	move.l	(sp),d1
	rts
.there	dc.l	0

.die	suicide	10

decrypt_end_10
decrypt_len_10	equ	decrypt_end_10-decrypt_code_10

;		1     ,2        ,3        ,4   ,5   ,6   ,7   ,8   , 9	, 10
various	macro	number,eor value,add value,pos?,eor?,add?,sub?,ror?,comb,comb
encrypt_code_\1
	move.l	the_start,a0

	move.l	sp,a6
	move.w	sr,d7
	move.w	#$2700,sr

.oh\@	move.l	#15,d0			; do 16 long words
	move.l	.oh\@+4(pc),d2	
.x\@
	move.l	(a0),d1

	ifne	\10
	eor.l	#\2,d1
	elseif
	sub.l	#\2,d1
	endc
	ifne	\9
	sub.l	#\3,d1
	elseif
	eor.l	#\3,d1
	endc
	ifne	\8
	rol.l	d0,d1
	endc
	ifne	\7
	move.w	#$2700,sr
	add.l	d0,d1
	endc
	ifne	\6
	sub.l	d0,d1
	endc
	ifne	\5
	eor.l	d0,d1
	move.w	#$2700,sr
	endc
	ifne	\4
	eor.l	d2,d1
	endc
	move.l	d1,(a0)+
	dbf	d0,.x\@

	move.l	a6,sp
	move.w	d7,sr

	rts
encrypt_end_\1
encrypt_len_\1	equ	encrypt_end_\1-encrypt_code_\1

decrypt_code_\1


	subq.l	#8,a6
	move.l	a6,a0
	add.l	the_start(a6),a0
	lea	.x\@+6(pc),sp

.oh\@	move.l	#15,d0			; do 16 long words
	move.l	.oh\@+4(pc),d2	
.x\@
	move.l	(a0),d1
	ifne	\4
	eor.l	d2,d1
	lea	.x\@+4(pc),sp
	endc
	ifne	\5
	eor.l	d0,d1
	move.w	#$2700,sr
	endc
	ifne	\6
	add.l	d0,d1
	move.l	#-1,sp
	endc
	ifne	\7
	move.w	#$2700,sr
	sub.l	d0,d1
	endc
	ifne	\8
	ror.l	d0,d1
	move.l	#-1,sp
	endc
	ifne	\9
	add.l	#\3,d1
	elseif
	eor.l	#\3,d1
	endc
	ifne	\10
	move.l	#-1,sp
	eor.l	#\2,d1
	elseif
	add.l	#\2,d1
	endc
	move.l	d1,(a0)+
	dbf	d0,.x\@

	move.w	#$2700,sr
	move.w	#$2700,sr
	move.w	#$2700,sr
	suicide	\1
decrypt_end_\1
decrypt_len_\1	equ	decrypt_end_\1-decrypt_code_\1

	endm

	various	11,123456,222222,0,0,0,0,0,0,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	various	12,"MICK","WEST",0,0,0,0,1,0,0
	various	13,"WEST","MICK",0,0,0,1,0,0,0
	various	14,"POOP","POPP",0,0,0,1,1,0,0
	various	15,"WIGG","WOGG",0,0,1,0,0,0,0
	various	16,"pipp","OFF!",1,0,1,0,1,0,0
	various	17,"SILL","YBOY",0,1,1,1,0,0,0
	various	18,"GO..","AWAY",0,0,1,1,1,0,0

	various	19,"MICX","YEST",0,1,0,0,1,0,0
	various	20,"WESX","YICK",0,1,0,1,0,0,0
	various	21,"POOX","YOPP",0,1,0,1,1,0,0
	various	22,"WIGX","YOGG",0,1,1,0,0,0,0
	various	23,"pUCX","YFF!",0,1,1,0,1,0,0
	various	24,"SILX","YBOY",0,1,1,1,0,0,0
	various	25,"GO.X","YWAY",0,1,1,1,1,0,0

	various	26,"QICK","WE1T",1,0,0,0,1,0,0
	various	27,"QEST","MI1K",1,0,0,1,0,0,0
	various	28,"QOOP","PO1P",1,0,0,1,1,0,0
	various	29,"QIGG","WO1G",1,0,1,0,0,0,0
	various	30,"QUCK","OF1!",1,0,1,0,1,0,0
	various	31,"QILL","YB1Y",1,0,1,1,0,0,0
	various	32,"QO..","AW1Y",1,0,1,1,1,0,0

	various	33,"QICX","YE1T",1,1,0,0,1,0,0
	various	34,"QESX","YI1K",1,1,0,1,0,0,0
	various	35,"QOOX","YO1P",1,1,0,1,1,0,0
	various	36,"QIGX","YO1G",1,1,1,0,0,0,0
	various	37,"QUCX","YF1!",1,1,1,0,1,0,0
	various	38,"QILX","YB1Y",1,1,1,1,0,0,0
	various	39,"LE39","STEP",1,1,1,1,1,0,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	various	41,"WEST","MICK",0,0,0,1,0,0,1
	various	42,"POOP","POPP",0,0,0,1,1,0,1
	various	43,"WIGG","WOGG",0,0,1,0,0,0,1
	various	44,"pipp","OFF!",1,0,1,0,1,0,1
	various	45,"SILL","YBOY",0,1,1,1,0,0,1
	various	46,"GO..","AWAY",0,0,1,1,1,0,1

	various	47,"MICX","YEST",0,1,0,0,1,0,1
	various	48,"WESX","YICK",0,1,0,1,0,0,1
	various	49,"POOX","YOPP",0,1,0,1,1,0,1
	various	50,"WIGX","YOGG",0,1,1,0,0,0,1
	various	51,"pUCX","YFF!",0,1,1,0,1,0,1
	various	52,"SILX","YBOY",0,1,1,1,0,0,1
	various	53,"GO.X","YWAY",0,1,1,1,1,0,1

	various	54,"QICK","WE1T",1,0,0,0,1,0,1
	various	55,"QEST","MI1K",1,0,0,1,0,0,1
	various	56,"QOOP","PO1P",1,0,0,1,1,0,1
	various	57,"QIGG","WO1G",1,0,1,0,0,0,1
	various	58,"QUCK","OF1!",1,0,1,0,1,0,1
	various	59,"QILL","YB1Y",1,0,1,1,0,0,1
	various	60,"QO..","AW1Y",1,0,1,1,1,0,1

	various	61,"QICX","YE1T",1,1,0,0,1,0,1
	various	62,"QESX","YI1K",1,1,0,1,0,0,1
	various	63,"QOOX","YO1P",1,1,0,1,1,0,1
	various	64,"QIGX","YO1G",1,1,1,0,0,0,1
	various	65,"QUCX","YF1!",1,1,1,0,1,0,1
	various	66,"QILX","YB1Y",1,1,1,1,0,0,1
	various	67,"LE39","STEP",1,1,1,1,1,0,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	various	68,"MICK","WEST",0,0,0,0,1,1,0
	various	69,"WEST","MICK",0,0,0,1,0,1,0
	various	70,"POOP","POPP",0,0,0,1,1,1,0
	various	71,"WIGG","WOGG",0,0,1,0,0,1,0
	various	72,"pipp","OFF!",1,0,1,0,1,1,0
	various	73,"SILL","YBOY",0,1,1,1,0,1,0
	various	74,"GO..","AWAY",0,0,1,1,1,1,0

	various	75,"MICX","YEST",0,1,0,0,1,1,0
	various	76,"WESX","YICK",0,1,0,1,0,1,0
	various	77,"POOX","YOPP",0,1,0,1,1,1,0
	various	78,"WIGX","YOGG",0,1,1,0,0,1,0
	various	79,"pUCX","YFF!",0,1,1,0,1,1,0
	various	80,"SILX","YBOY",0,1,1,1,0,1,0
	various	81,"GO.X","YWAY",0,1,1,1,1,1,0

	various	82,"QICK","WE1T",1,0,0,0,1,1,0
	various	83,"QEST","MI1K",1,0,0,1,0,1,0
	various	84,"QOOP","PO1P",1,0,0,1,1,1,0
	various	85,"QIGG","WO1G",1,0,1,0,0,1,0
	various	86,"QUCK","OF1!",1,0,1,0,1,1,0
	various	87,"QILL","YB1Y",1,0,1,1,0,1,0
	various	88,"QO..","AW1Y",1,0,1,1,1,1,0

	various	89,"QICX","YE1T",1,1,0,0,1,1,0
	various	90,"QESX","YI1K",1,1,0,1,0,1,0
	various	91,"QOOX","YO1P",1,1,0,1,1,1,0
	various	92,"QIGX","YO1G",1,1,1,0,0,1,0
	various	93,"QUCX","YF1!",1,1,1,0,1,1,0
	various	94,"QILX","YB1Y",1,1,1,1,0,1,0
	various	95,"LE39","STEP",1,1,1,1,1,1,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	various	96,"MICK","WEST",0,0,0,0,1,1,1
	various	97,"WEST","MICK",0,0,0,1,0,1,1
	various	98,"POOP","POPP",0,0,0,1,1,1,1
	various	99,"WIGG","WOGG",0,0,1,0,0,1,1
	various	100,"pipp","OFF!",1,0,1,0,1,1,1
	various	101,"SILL","YBOY",0,1,1,1,0,1,1
	various	102,"GO..","AWAY",0,0,1,1,1,1,1

	various	103,"MICX","YEST",0,1,0,0,1,1,1
	various	104,"WESX","YICK",0,1,0,1,0,1,1
	various	105,"POOX","YOPP",0,1,0,1,1,1,1
	various	106,"WIGX","YOGG",0,1,1,0,0,1,1
	various	107,"pUCX","YFF!",0,1,1,0,1,1,1
	various	108,"SILX","YBOY",0,1,1,1,0,1,1
	various	109,"GO.X","YWAY",0,1,1,1,1,1,1

	various	110,"QICK","WE1T",1,0,0,0,1,1,1

	various	111,"QI2K","aE1T",1,1,0,0,1,1,1
	various	112,"QI3K","sE1T",1,1,0,0,1,1,1
	various	113,"QI4K","dE1T",1,0,1,0,1,1,1
	various	114,"QI5K","fE1T",1,0,1,0,1,1,1
	various	115,"QI6K","gE1T",1,0,1,0,1,1,1
	various	116,"QI7K","hE1T",1,1,0,0,1,1,1
	various	117,"QI8K","jE1T",1,0,0,0,1,1,1
	various	118,"QI9K","kE1T",1,1,0,0,1,1,1
	various	119,"QI0K","lE1T",1,1,0,1,1,1,1


	various	120,"QEST","MI1K",1,0,0,1,0,1,1
	various	121,"QOOP","PO1P",1,0,0,1,1,1,1
	various	122,"QIGG","WO1G",1,0,1,0,0,1,1
	various	123,"QUCK","OF1!",1,0,1,0,1,1,1
	various	124,"QILL","YB1Y",1,0,1,1,0,1,1
	various	125,"QO..","AW1Y",1,0,1,1,1,1,1

	various	126,"QICX","YE1T",1,1,0,0,1,1,1
	various	127,"QESX","YI1K",1,1,0,1,0,1,1
	various	128,"QOOX","YO1P",1,1,0,1,1,1,1
	various	129,"QIGX","YO1G",1,1,1,0,0,1,1
	various	130,"QUCX","YF1!",1,1,1,0,1,1,1
	various	131,"QILX","YB1Y",1,1,1,1,0,1,1
	various	132,"LE39","STEP",1,1,1,1,1,1,1


; *********************************************************************
; number 40 encryption routine
; Does bugger all to the data - just puts in a text message

encrypt_code_40
	rts
encrypt_end_40
encrypt_len_40	equ	encrypt_end_40-encrypt_code_40

decrypt_code_40
	subq.l	#8,a6
	bra	.die
	dc.b	"  Well, bugger me! I spent hours on that encryption"
	dc.b	" routine and you go and crack it in no time at all"
	dc.b	". Well, I hope you enjoyed it as there are about "
	dc.b	"a thousand more levels to go, all of them different "
	dc.b	"and that was the easiest of the lot ...........! "
	even
.die	suicide	40
decrypt_end_40
decrypt_len_40	equ	decrypt_end_40-decrypt_code_40


; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; table of encryption routines
; encrypt_code,encrypt_len,decrypt_code,decrypt_len

crypt	macro	number
	dc.l	encrypt_code_\1,encrypt_len_\1,decrypt_code_\1,decrypt_len_\1
	endm

crypt_table
crypt_number	set	0
	rept	132+1
	crypt	\#crypt_number
crypt_number	set	crypt_number+1
	endr


; table of numbers of encryption routines to use - end with -1
; when choosing these remember that the hacker will encounter
; them in reverse order so give him the easy ones first, maybe?
; always use all the routines available - and some more than once

; leave the 40,1 at the end to have a message after first level 

; dont use 9 or 10  as they are position dependent

usage_table
	dc.w	1,2,3,4,5,7,8
	dc.w	8,7,5,4,3,2,1
	rept	4
	dc.w	11,12,13,14,15,16,17,18,19
	dc.w	20,21,22,23,24,25,26,27,28,29
	dc.w	30,31,32,33,34,35,36,37,38,39
	dc.w	41,42,43,44,45,46,47,48,49,50
	dc.w	51,52,53,54,55,56,57,58,59,60
	dc.w	61,62,63,64,65,66,67,68,69,70
	dc.w	71,72,73,74,75,76,77,78,79,80
	dc.w	81,82,83,84,85,68,78,88,89,90
	dc.w	91,92,93,94,95,96,97,98,99,100
	dc.w	101,102,103,104,105,106,107,108,109,100
	dc.w	111,112,113,114,115,116,117,118,119,120
	dc.w	121,122,123,124,125,126,127,128,129,130
	dc.w	131,132
	endr
	dc.w	40		; message and one level of encryption
	dc.w	6
	DC.W	-1		

hello_mess	dc.b	" Crackers Nightmare :-( "
	even

use_file_dest	dc.w	0	

;bbuffer		equ	end	; the start of the program buffer

