;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; OBSCURE.S - Macros and routines to implement normal routines
; in a obscure manner (for anti-hacker protection)
; most assume a6 & d7 are free
;
; some may use SM code, will be commented as so
; 
; Multipart routines should be used with some code between the parts a,b,c

__obscure

; ojsr is quite simple
ojsr1	macro	address
	move.l	#\1/2,d7
	pea	.ret\@
	move.l	d7,-(sp)
	not.l	d7
	addq.l	#1,d7
	neg.l	d7
	add.l	d7,(sp)
	rts 
.ret\@
	endm

; ojsr2 is position dependent, hence diff encoding each time you use it
ojsr2	macro	address
	pea	.ret\@
.x\@	move.l	.data\@(pc),-(sp)
	move.l	a7,-(a7)
	lea	.x\@(pc),a6
	move.l	a6,d7
	move.l	(a7)+,a6
	eor.l	d7,(a6)
	rts
.data\@	dc.l 	\1^.x\@
.ret\@
	endm
      
; ojsr3 uses the SR register to make it slightly trickier to trace through
ojsr3	macro	address

	move.w	sr,-(sp)
	move.w	#.ret\@&$ffff,-(Sp)
	move.w	#$2700,sr
	lea	$43126,a6
	move.w	#.ret\@>>16,-(Sp)
	move.w	sr,-(sp)
	move.w	a6,-(sp)
	move.l	#(~($31262700^~\1))>>1,d7
	lsl.l	#1,d7
	eor.l	d7,(sp)
	rts
	move.w	sr,-(sp) 		; dumy code
	move.w	#$2700,sr
	jsr	$32688
.ret\@
	move.w	(sp)+,sr

	endm   

; a quick & short one to just disguise the address from searches 
ojsr4	macro	  address
	lea	\1/2,a6
	add.l	a6,a6
	jsr	(A6)
	endm

; another quick one, but with a number to eor with the addr
ojsr5	macro	address,number
	move.l	#\1^\2,d7
	eor.l	#\2,d7
	move.l	d7,a6
	jsr	(a6)
	endm

; now some leas
olea1	macro	addr,reg
	lea	\1/2,\2
	add.l	a0,a0
	endm

olea2	macro	addr,reg,number
	move.l	\1^\3,d7
	eor.l	#\3,d7
	move.l	d7,\2
	endm
	
	
	
; macros for checking the rom	

	ifne	st			
get_rom	macro 	;variable, eor value
	tst.l	\1
	bne.s	.done\@
	move.l	4.w,d0
	clr.b	d0
	and.w	#$ff00,d0
	move.l	d0,a0
	move.l	$18(a0),d0
	add.l	\2,d0
	move.l	d0,\1
.done\@
	endm

check_rom	macro  ;variable, eor value, crash address
	tst.l	\1
	beq.s	.done\@
	move.l	4.w,d0
	clr.b	d0
	move.l	d0,a0
	move.l	$18(a0),d0
	add.l	\2,d0
	sub.l	\1,d0
	sub.l	d0,\3
.done\@
	endm	

	elseif
get_rom	macro
	endm

check_rom	macro
	endm

	endc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; TOP - a macro for a routine to comit suicide by
top	macro	routine start
	lea	\1,a0			; start of routine
	move.w	#(.x-\1)/2-4,d0
.x	move.w	#$4e75,(a0)+  		; fill with rts's 
	dbf	d0,.x			; will eventually eat itself and RTS
	rts
	endm				; leaving just the bra .x
	

; end of OBSCURE.S
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
